# Point To It

This unofficial TaleSpire plugin allows players to activate a pointer similar to the GM's flashlight
to point out things on the map. Comes with two default pointers but can be configured to use any mini
as a pointer allowing the users to make custom pointers.

This plugin, like all others, is free but if you want to donate, use: http://LordAshes.ca/TalespireDonate/Donate.php

## Change Log

```
1.0.0: Initial release
```

## Install

Use R2ModMan or similar installer to install this plugin.

## Usage

### Basic Mode

Activate pointer mode by pressing the corresponding keyboard shortcut on the keyboard (default ``LSHIFT``+``1``).
A message will appear on all devices that the user is pointing. No pointer will appear until the pointing user
clicks a location. The pointer will appear at that location and will be visible to all other players. Any additional
clicks will move to pointer to that location. To turn off pointer mode, press the same keyboard shortcut that was
used to activate the mode to toggle it off.

Default: ``LSHIFT``+``1`` (do not use the 1 on the numeric keypad)

### Advanced Mode [In Testing]

There are two variations on the above Basic Mode which are activate by their own keyboard shortcuts. These advanced
functions are always available to the GM but are available to players only if the GM policy allows it. As part of the
configruation for this plugin, the GM can allows users to use these function (default is to not allow). When a player
connects to the session, it requests the GM's policy and uses those settings as opposed to its own configruation. This
allows the setting to be controlled by the GM as opposed to each player.

Default Keyboard Shortcuts:

``LSHIFT``+``2``: Pointer with GM Pull

``LSHIFT``+``3``: Pointer with All Pull

These variations work just like the basic mode but they also change the GM's (in the GM Pull option) or all players
including the GM (in the All Pull option) view to match the pointing player. This can be very helpful if the session
is taking place over a large map and the GM would constantlty need to move between player areas to see where they are
pointing. By allowing players to do a GM pull, when they point the GM's view will automatically be shifted to their
part of the map.

Note: The pull functionality is still in testing. If you try it and it does not work, please leave a comment. If you
try it and it does work, please leave a comment.

### Configuration

The plugin has a few configuration parameters that can be modified. Typically this is done using R2ModMan's Edit Config
function. The exposed setting are:

Toggle Pointer: Determines the key used to toggle the pointer.
Toggle Pointer And GM Pull: Determines the key used to toggle the pointer with GM pull (if allowed).
Toggle Pointer And Player (All) Pull: Determines the key used to toggle the pointer with all pull (if allowed).
Pointer Asset Bundle Name: Determines the asset bundle name in which the desired pointer is stored.
Pointer Prefab Name: Determines the prefab name within the asset bundle of the pointer to be used.

The plugin comes with two pointers: ``lapointerlight01`` and ``lapointerlight02``. Both pointers are columns of particles
descending on the pointed space but each has a different animation speed. The asset bundle name and refab name are the
same for both pointers. The asset bundle name and prefab name can be changed to use any mini as a pointer. Generally,
however, you want to use a mini that has a large height (such as the default pointer columns) or has some other meachanism
to attract attension so that it is obvious that it is a pointer.

## Limitation

1. While the plugin should support multiple players pointing at the same time with each pointing player having his/her
own pointer, currently all players use a copy of the same pointer so all the pointers will look the same (making it
difficult to tell which pointer belongs to which player).

2. The plugin automatically tried to determine elevation vs position based on where you clicked. If the plugin is not
interpreting your click properly (e.g. you are clicking on top of a elevated section but the plugin is interprting it
as behind the elevated section or vice versa) then try rotating your view and clicking again.

3. There is not support, at this time, for a private pointer only visible by the user and the GM.

4. The pointer being used for this plugin should NOT be spawen on the board like a regular mini. This plugin should be
the only plugin spawning the pointer. If the pointer is placed on the board by taking it out of the library like any other
mini, this plugin will not work.
